Scriptname PA_POP_Config extends SKI_ConfigBase Conditional

PA_POP_PilloryQuest Property PilloryQuest Auto
GlobalVariable Property PilloryMaxEvents Auto
String[] MaxEvents

Bool Property PilloryTats Auto Conditional
Float Property PillorySexChance = 50.0 Auto

Event OnPageReset(string page)
	SetCursorFillMode(TOP_TO_BOTTOM)
	AddHeaderOption("Pillory")
	optPilloryTat = AddToggleOption("Apply Tattoos", PilloryTats)
	optPilloryEvents = AddMenuOption("Number of Patrons", PilloryMaxEvents.GetValue() as int)
	optPillorySex = AddSliderOption("Sex Chance", PillorySexChance, "{0}%")
EndEvent

Event OnOptionSelect(int opt)
	if opt == optPilloryTat
		PilloryTats = !PilloryTats
		if !Game.GetModByName("SlaveTats.esp")
			PilloryTats = false
		endIf
		
		SetToggleOptionValue(optPilloryTat, PilloryTats)
	endIf
EndEvent

Event OnOptionDefault(int opt)
	if opt == optPilloryTat
		PilloryTats = false
		SetToggleOptionValue(optPilloryTat, PilloryTats)
	elseIf opt == optPillorySex
		PillorySexChance = 50.0
		SetSliderOptionValue(opt, PillorySexChance, "{0}%")
	elseIf opt == optPilloryEvents
		PilloryMaxEvents.SetValue(3)
		SetMenuOptionValue(optPilloryEvents, PilloryMaxEvents.GetValue() as int)
	endIf
EndEvent

Event OnOptionHighlight(int opt)	
	if (opt == optPilloryTat)
		SetInfoText("Apply tattoos during the pillory event")
	elseIf (opt == optPilloryEvents)
		SetInfoText("Number of people who will visit you in the pillory")
	endIf
EndEvent

event OnOptionSliderOpen(int opt)
	if (opt == optPillorySex)
		SetSliderDialogStartValue(PillorySexChance)
		SetSliderDialogDefaultValue(50)
		SetSliderDialogRange(0, 100)
		SetSliderDialogInterval(2)
	endIf
endEvent

event OnOptionSliderAccept(int opt, float val)
	if (opt == optPillorySex)
		PillorySexChance = val
		SetSliderOptionValue(opt, val, "{0}%")
	endIf
endEvent

event OnOptionMenuOpen(int opt)
	if (opt == optPilloryEvents)
		MaxEvents = new string[11]
		int i = 0
		while i < MaxEvents.Length
			MaxEvents[i] = i as string
			i += 1
		endWhile
		SetMenuDialogStartIndex(PilloryMaxEvents.GetValue() as int)
		SetMenuDialogDefaultIndex(4)
		SetMenuDialogOptions(MaxEvents)
	endIf
endEvent

event OnOptionMenuAccept(int opt, int ind)
	if (opt == optPilloryEvents)
		PilloryMaxEvents.SetValue(ind as int)
		SetMenuOptionValue(optPilloryEvents, PilloryMaxEvents.GetValue() as int)
	endIf
endEvent

int optPilloryTat
int optPilloryEvents
int optPillorySex