Scriptname PA_POP_EscortLauncher extends Quest  

;Indexes: +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; 0= Whiterun / 1=Solitude / 2=Windhelm / 3=Morthaal / 4=Falkreath / 5=Dawnstar / 6=Riften
; 0= pilloryScene
faction[] property crimeFactions Auto
quest[] property afterEscortQuests auto
quest property AfterEscortQuest auto
quest property Escort auto
Quest Property ParadeQuest Auto

ReferenceAlias[] Property Starts Auto

;Aliase
ReferenceAlias property victim1_start_a auto 
ReferenceAlias property victim1_target_a auto 

ReferenceAlias property victim2_start_a auto 
ReferenceAlias property victim2_target_a auto 

ReferenceAlias property escort1_start_a auto 
ReferenceAlias property escort1_target_a auto 

ReferenceAlias property escort2_start_a auto 
ReferenceAlias property escort2_target_a auto 

;ObjectReferences PilloryScene
ObjectReference[] property pillory_victim1_start auto 

ObjectReference[] property pillory_victim2_start auto 

ObjectReference[] property pillory_escort1_start auto 
ObjectReference[] property pillory_escort1_target auto 

ObjectReference[] property pillory_escort2_start auto 

ObjectReference[] property pillories_1 auto
ObjectReference[] property pillories_2 auto

;ObjectReferences Parade
ObjectReference[] Property parade_escort1_start auto
ObjectReference[] Property parade_escort2_start auto
ObjectReference[] Property parade_victim1_start auto


function InitializePilloryEscort(Faction crimeFaction = none, string cityname = "")
	Debug.Trace("PAPOP: Initializing pillory escort")

	int tmp=3 
	if crimefaction == crimefactions[0] || cityname== "Whiterun"
		tmp=0
	else
		tmp = 0
	EndIf

	If skipEscort
		skippedEscort.SetValue(skipEscort[tmp] as int)
		Debug.Trace("PAPOP: Skipping escort? " + skipEscort[tmp])
	EndIf

	Debug.Trace("PAPOP: Location chosen " + tmp)

	escort1_leave_target_a.forceRefTo(PilloryEscort1LeaveTargets[tmp])
	
	victim1_start_a.forceRefTo(pillory_victim1_start[tmp])

	victim2_start_a.forceRefTo(pillory_victim2_start[tmp])

	escort1_start_a.forceRefTo(pillory_escort1_start[tmp])
	escort1_target_a.forceRefTo(pillory_escort1_target[tmp])

	escort2_start_a.forceRefTo(pillory_escort2_start[tmp])

	pillories_1[tmp].enable()
	
	if FollowerPresent.GetValue()
		pillories_2[tmp].enable()
	endIf

	Quest q= afterEscortQuests[0]


	setAfterEscortQuest(q)
endFunction


function StartEscort()
	Debug.Trace("Starting actual escort")
	Escort.start()
EndFunction

Function InitializeParade(Faction crimeFaction)
	int tmp
	if crimefaction == crimefactions[0]
		tmp = 0
	else
		tmp = 0
	EndIf

	;/
	Starts[0].forceRefTo(parade_escort1_start[tmp])
	Starts[1].forceRefTo(parade_escort2_start[tmp])
	Starts[2].forceRefTo(parade_victim1_start[tmp])
	/;
	Debug.Trace("Refs set to: " + starts[0].GetRef() + " " + starts[1].GetRef() + " " + starts[2].GetRef())

EndFunction

	
function setAfterEscortQuest(quest followUpQuest)
	AfterEscortQuest = followUpQuest
EndFunction

Bool[] Property SkipEscort  Auto  

GlobalVariable Property SkippedEscort  Auto  

GlobalVariable Property followerPresent  Auto  

ObjectReference[] Property PilloryEscort1LeaveTargets  Auto  

ReferenceAlias Property escort1_leave_target_a  Auto  
