Scriptname PA_POP_Event_PublicWhore extends PamaPA_EventTemplate  
{This script ALWAYS needs to be attached to ANY Alias which ALWAYS points at the player. Dont Forgett to give your Event a name and set its EventType. This is done via the properties}

;ONINIT+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Function OnModuleInit()
	;Use this Function Instead of the 'OnInit' Event.	////
EndFunction


;CHECK IF YOUR EVENT CAN BE PLAYED AT THE CURRENT SITUATION++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Bool Function CheckPluginConditions(Actor Prisoner, Actor Follower, Actor thisLocationsDetainee, Faction JailorCrimeFaction, int crimeSeverity, int currentDay, int maxDay, int NumberMisconducts, int restraintSeverity, Armor currentCuffs, ObjectReference PrisonBed, bool AllowLethalEvents, int LethalSurvivalChance)
	;Actor Prisoner				//// 		The Player
	;Actor Follower				////		the imprisoned Follower (can be none); WARNING: if you want to use any AI packages on him, the Owning Quests priority has to be higher than 60!
	;Actor ThisLocationsDetainee	////		A detained NPC if this crimefaction has one (those who sit in the cages). Usually a former follower which has been left behind after an earlier succesfull escape. but anything can be detained with the API functions. Can be none.
	;Faction JailorCrimeFaction	////		where the player is imprisoned, ie. Whiterun/Falkreath/....
	;int CrimeSeverity			////		The severity of the players crime as determined by the initial bounty. 1=petty Crime / 2=regular Crime/ 3=Severe Crime
	;int currentDay				////		for How many 'Days' the player has already been in Jail. starts at 0
	;int maxDay					////		for how many 'Days' the player will be in Prison. ranges from 1-3
	;int numberMisconducted		////		how many times the player has been re-detained after Attacking/Stealing/Failed escapes. starts at 0 and has no upper limit
	;int restraintSeverity			////		this is usually equivalent to the CrimeSeverity, but can be limited by MCM settings. 0 = no restraints / 1 =sliceable rope cuffs / 2=nonBreakable iron cuffs
	;Armor currentCuffs			////		returns the currently should-be-equipped-cuffs as Armor variable. In case you need to manually equip/unequip them
	;ObjectReference PrisonBed	////		The Prisoners Bed in his Cell
	
	;use the conditions to determine if your Event can and should play in the given circumstances	////

	if 255 != Game.GetModByName("Public Whore.esp")
		return true
	else
		return false
	EndIf

EndFunction


;PLAY YOUR EVENT ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	
Function ExecuteEvent(Actor Prisoner, Actor Follower, Actor thisLocationsDetainee, Faction JailorCrimeFaction, int crimeSeverity, int currentDay, int maxDay, int NumberMisconducts, int restraintSeverity, Armor currentCuffs, ObjectReference PrisonBed, bool AllowLethalEvents, int LethalSurvivalChance)

	;player will be in his cell at this point and a Blackfade will be Active. move him somewhere else if your Event requires it or remove the Blackfade and start immediatly	////

	OpenJailDoor()
	RemovePrisonCuffs()
	returnPrisonersBelongings()

	if follower && !thisLocationsDetainee && pamaPA_Main.getAPI().isDetentionSystemEnabled()
		pamaPA_Main.getAPI().DetainNPC(Follower, JailorCrimeFaction, crimeSeverity*500, teleportToCage = true, IsFormerPlayerFollower = true, alternativeOriginalOutfit = clearFollower(false))
	EndIf
	utility.wait(0.5)

	int i = 0
	int holdIndex = -1
	while i < JailorFactions.Length
		if JailorCrimeFaction == JailorFactions[i]
			Debug.Trace("PAPOP: Chose correct jailor faction " + JailorCrimeFaction.GetName())
			holdIndex = i
			i = JailorFactions.Length
		endIf

		i += 1
	endWhile

	utility.wait(1.0)
	removeBlackfade()

	if holdIndex < 0
		Debug.Trace("PAPOP: Couldn't find correct faction index")

	else
		Debug.Trace("PAPOP: Setting hold index to " + holdIndex)
		PA_POP_HoldIndex.SetValue(holdIndex)
		Debug.Trace("PAPOP: Set hold index to " + Intro.HoldIndex)
		Game.SetPlayerAIDriven(true)
		Intro.Start()
	endIf

EndFunction


;INTERRUPT ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Event OnInterrupt(String EventName, String notUsed, float AlsoNotUsed, form Sender)
	;This fires if the player is detained after Attacking someone or stealing something. use it to immediatly shut down your scene!		////
	;Can be ignored if you make sure the player cannot missbehave during your scene		////
EndEvent


;USABLE FUNCTIONS++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Function OpenJailDoor()									////		This opens the Players cell door without triggering Guard agression

;Function returnPrisonersBelongings()						////		moves the contents of the Prisoners Belongings chest back to the Players inventory

;Function RemovePrisonCuffs()							////		 removes the special prison restraints. this has to be done before trying to equip anything else on the player!

;Outfit Function ClearFollower(bool restoreOriginalOutfit)	////		Releases the currently shackled follower (if present). returns the outfit he was wearing before being incarcerated. pass in a 'false' if you dont want him to re-dress his original outfit.

;Function Blackfade()										////		Applies a BlackFade	NOTE: movement functions like moveto() or setPosition used on the player cancel any Blackfade. therefore you should re-apply it immediatly after invoking movement functions.

;Function removeBlackfade()								////		removes the BlackFade

;Function DisableGuardAgression()							////		Disables the entire escape Detection System and Guard hostility. Use this at the very start of your Event requires the player to be moved out of prison. (If you used this, please use 'EventFinished(true)' at the End of your Event)
;Function SetPlayerEscaped()								////		Sets the player as free and shuts down the quest. Does NOT reset the player to his cell. WARNING: should only be used IF disableGiardAgression() has been used at the Start of the Event.

;Function ForceTriggerEscapeAttempt()					////		This is meant to be used in conjuction with the Function above. It will Force start an Escape attempt. The Guards will become hostile again and try to detain the player. The usual rules for a sucessfull escape still apply

;Function AdvanceDay()									////		Has the same effect as sleping in the Prison Bed after an Event. WARNING! if you want to use this, you should call 'EventFinished(false)' beforehand

;Function ForceNextDailyEventTo(String PluginName)		//// Forces the next Daily Event to the One with the passed in Name. The Event will ignore all conditions. this can be used to chain certain events together (Name is the 'PluginName' property inherited from the parentscript)

;Function ForceNextPunishingEventTo(String PluginName)	//// Same as above, but for punishing Events

;Function ForceNextReleaseEventTo(String PluginName)		//// Same as above, but for Release Events

;Function EndPrisonStatus()								////		Ends the Prison sentence and sets the player status as free. will reset the player to his cell and shut down the entire quest. NONE OF THE OTHER FUNCTIONS WILL WORK AFTER CALLING THIS!

;Custom============================
Message property MSG_PublicWhoreOutcome Auto

Faction[] Property JailorFactions  Auto 

PA_POP_PublicWhoreIntro Property Intro Auto 

GlobalVariable Property PA_POP_HoldIndex Auto
