Scriptname PA_POP_TattooManager extends Quest Conditional

String[] PillorySections
String[] PilloryNames

String[] ParadeSections
String[] ParadeNames

Int Property Max Auto

Function ApplyPilloryTattoos(Actor akTarget)
    string TattooJSON = "../PA POP Addon/tattoos"
    
    Debug.Trace("PAPOP: Adding Pillory tattoos" + JsonUtil.IsGood(TattooJSON) + " " + JsonUtil.GetErrors(TattooJSON))
    PillorySections = JsonUtil.StringListToArray(TattooJSON, "pillory-sections")
    PilloryNames = JsonUtil.StringListToArray(TattooJSON, "pillory-names")

    ApplyTattoos(akTarget, PillorySections, PilloryNames)
EndFunction

Function RemovePilloryTattoos(Actor akTarget)
    Debug.Trace("PAPOP: Removing Pillory tattoos")
    RemoveTattoos(akTarget, PillorySections, PilloryNames)
EndFunction

Function ApplyParadeTattoos(Actor akTarget)
    string TattooJSON = "../PA POP Addon/tattoos"
    
    Debug.Trace("PAPOP: Adding Parade tattoos" + JsonUtil.IsGood(TattooJSON) + " " + JsonUtil.GetErrors(TattooJSON))
    ParadeSections = JsonUtil.StringListToArray(TattooJSON, "parade-sections")
    ParadeNames = JsonUtil.StringListToArray(TattooJSON, "parade-names")

    ApplyTattoos(akTarget, ParadeSections, ParadeNames)
EndFunction

Function RemoveParadeTattoos(Actor akTarget)
    RemoveTattoos(akTarget, ParadeSections, ParadeNames)
EndFunction

Function ApplyTattoos(Actor akTarget, String[] Sections, String[] Names) 
    if !akTarget || !Sections || !Names
        return
    endIf

    Max = Sections.Length
    if Names.Length < Max
        Max = Names.Length
    endIf
    Debug.Trace("PAPOP: S" + PillorySections.Length + " N" + Names.Length + " M" + Max)

    int i = 0
    while i < Max
        Debug.Trace("PAPOP: Adding tattoo " + Sections[i] + "/" + Names[i])
        SlaveTats.simple_add_tattoo(akTarget, Sections[i], Names[i], 0, i == (Max - 1), true)
        i += 1
    endWhile
EndFunction

Function RemoveTattoos(Actor akTarget, String[] Sections, String[] Names)
    if !akTarget || !Sections || !Names
        return
    endIf

    int i = 0

    while i < Max
        SlaveTats.simple_remove_tattoo(akTarget, PillorySections[i], PilloryNames[i], i == (Max - 1), true)
        i += 1
    endWhile
EndFunction